/*---------------------------------------------------------------------------*\
** $Author: saulius $
** $Date: 2011-03-08 18:45:40 +0000 (Tue, 08 Mar 2011) $ 
** $Revision: 1590 $
** $URL: svn://www.crystallography.net/cod-tools/trunk/CIFParser-c/libs/cexceptions/stdiox.c $
\*---------------------------------------------------------------------------*/

/* exports: */
#include <stdiox.h>

/* uses: */
#include <cexceptions.h>
#include <cxprintf.h>
#include <errno.h>
#include <string.h>

void *stdiox_subsystem = &stdiox_subsystem;

FILE *fopenx( const char *filename, const char *mode, cexception_t *ex )
{
    FILE *f = fopen( filename, mode );

    if( f == NULL ) {
        cexception_raise_in( ex, stdiox_subsystem, STDIOX_FILE_OPEN_ERROR,
			     cxprintf( "could not open file '%s': %s",
				       filename, strerror( errno )));
    }

    return f;
}

void fclosex( FILE *file, cexception_t *ex )
{
    if( fclose( file ) != 0 ) {
        cexception_raise_in( ex, stdiox_subsystem, STDIOX_FILE_CLOSE_ERROR,
			     cxprintf( "could not close file: %s",
				       strerror( errno )));
    }
}
